/* Produced by CVXGEN, 2020-04-11 14:05:42 -0400.  */
/* CVXGEN is Copyright (C) 2006-2017 Jacob Mattingley, jem@cvxgen.com. */
/* The code in this file is Copyright (C) 2006-2017 Jacob Mattingley. */
/* CVXGEN, or solvers produced by CVXGEN, cannot be used for commercial */
/* applications without prior written permission from Jacob Mattingley. */

/* Filename: testsolver.c. */
/* Description: Basic test harness for solver.c. */
#include "solver.h"
Vars vars;
Params params;
Workspace work;
Settings settings;
#define NUMTESTS 0
int main(int argc, char **argv) {
  int num_iters;
#if (NUMTESTS > 0)
  int i;
  double time;
  double time_per;
#endif
  set_defaults();
  setup_indexing();
  load_default_data();
  /* Solve problem instance for the record. */
  settings.verbose = 1;
  num_iters = solve();
#ifndef ZERO_LIBRARY_MODE
#if (NUMTESTS > 0)
  /* Now solve multiple problem instances for timing purposes. */
  settings.verbose = 0;
  tic();
  for (i = 0; i < NUMTESTS; i++) {
    solve();
  }
  time = tocq();
  printf("Timed %d solves over %.3f seconds.\n", NUMTESTS, time);
  time_per = time / NUMTESTS;
  if (time_per > 1) {
    printf("Actual time taken per solve: %.3g s.\n", time_per);
  } else if (time_per > 1e-3) {
    printf("Actual time taken per solve: %.3g ms.\n", 1e3*time_per);
  } else {
    printf("Actual time taken per solve: %.3g us.\n", 1e6*time_per);
  }
#endif
#endif
  return 0;
}
void load_default_data(void) {
  params.x_final[0] = 0.20319161029830202;
  params.x_final[1] = 0.8325912904724193;
  params.xk_0[0] = -0.8363810443482227;
  params.xk_0[1] = 0.04331042079065206;
  params.d_0[0] = 1.5717878173906188;
  params.d_0[1] = 1.5851723557337523;
  /* Make this a diagonal PSD matrix, even though it's not diagonal. */
  params.Q[0] = 1.1255853104638363;
  params.Q[2] = 0;
  params.Q[1] = 0;
  params.Q[3] = 1.2072428781381868;
  params.uk_0[0] = -1.7941311867966805;
  /* Make this a diagonal PSD matrix, even though it's not diagonal. */
  params.R[0] = 1.4408098436506365;
  params.alpha_0[0] = 0.05975242175713391;
  params.alpha_min[0] = 0.9136664487894222;
  /* Make this a diagonal PSD matrix, even though it's not diagonal. */
  params.M[0] = 1.6491440476147607;
  params.xk_1[0] = -0.8860508694080989;
  params.xk_1[1] = 0.7050196079205251;
  params.uk_1[0] = 0.3634512696654033;
  params.alpha_1[0] = 0.04796376475433073;
  params.xk_2[0] = 0.23541635196352795;
  params.xk_2[1] = -0.9629902123701384;
  params.uk_2[0] = -0.3395952119597214;
  params.alpha_2[0] = 0.5670501635426375;
  params.xk_3[0] = 0.7725516732519853;
  params.xk_3[1] = -0.23818512931704205;
  params.uk_3[0] = -1.372529046100147;
  params.alpha_3[0] = 1.0892980360636895;
  params.xk_4[0] = 1.1212590580454682;
  params.xk_4[1] = -0.774545870495281;
  params.uk_4[0] = -1.1121684642712744;
  params.alpha_4[0] = 0.7759425151112975;
  params.xk_5[0] = 1.7455345994417217;
  params.xk_5[1] = 1.9039816898917352;
  params.uk_5[0] = 0.6895347036512547;
  params.alpha_5[0] = 1.8056682170767961;
  params.xk_6[0] = 1.383003485172717;
  params.xk_6[1] = -0.48802383468444344;
  params.uk_6[0] = -1.631131964513103;
  params.alpha_6[0] = 1.3068218050470723;
  params.xk_7[0] = 0.2313630495538037;
  params.xk_7[1] = -0.5537409477496875;
  params.uk_7[0] = -1.0997819806406723;
  params.alpha_7[0] = 0.8130398327524972;
  params.xk_8[0] = -0.12423900520332376;
  params.xk_8[1] = -0.923057686995755;
  params.uk_8[0] = -0.8328289030982696;
  params.alpha_8[0] = 0.9153727986459559;
  params.xk_9[0] = 1.442135651787706;
  params.xk_9[1] = 0.34501161787128565;
  params.uk_9[0] = -0.8660485502711608;
  params.alpha_9[0] = 0.5559550132472026;
  params.xk_10[0] = -0.1815116979122129;
  params.xk_10[1] = -1.17835862158005;
  params.uk_10[0] = -1.1944851558277074;
  params.alpha_10[0] = 1.0280701196348838;
  params.xk_11[0] = -1.6510825248767813;
  params.xk_11[1] = -0.06565787059365391;
  params.uk_11[0] = -0.5512951504486665;
  params.alpha_11[0] = 1.4153732436313422;
  params.xk_12[0] = 0.9869848924080182;
  params.xk_12[1] = 0.7643716874230573;
  params.uk_12[0] = 0.7567216550196565;
  params.alpha_12[0] = 0.7472002482978566;
  params.xk_13[0] = 0.6725392189410702;
  params.xk_13[1] = -0.6406053441727284;
  params.uk_13[0] = 0.29117547947550015;
  params.alpha_13[0] = 0.651614316129749;
  params.xk_14[0] = -0.21941980294587182;
  params.xk_14[1] = -1.753884276680243;
  params.uk_14[0] = -1.0292983112626475;
  params.alpha_14[0] = 1.9432052123471353;
  params.xk_15[0] = -1.077663182579704;
  params.xk_15[1] = 0.7659100437893209;
  params.uk_15[0] = 0.6019074328549583;
  params.alpha_15[0] = 1.4478782788749642;
  params.xk_16[0] = -0.09964555746227477;
  params.xk_16[1] = 0.38665509840745127;
  params.uk_16[0] = -1.7321223042686946;
  params.alpha_16[0] = 0.14512427564446684;
  params.xk_17[0] = -1.2040958948116867;
  params.xk_17[1] = -1.3925560119658358;
  params.uk_17[0] = -1.5995826216742213;
  params.alpha_17[0] = 0.25858772921770834;
  params.xk_18[0] = 0.21311092723061398;
  params.xk_18[1] = -1.248740700304487;
  params.uk_18[0] = 1.808404972124833;
  params.alpha_18[0] = 1.3632235576148533;
  params.xk_19[0] = 0.16407869343908477;
  params.xk_19[1] = 0.8287224032315907;
  params.uk_19[0] = -0.9444533161899464;
  params.alpha_19[0] = 1.8534513685074556;
  params.xk_20[0] = 1.3567722311998827;
  params.xk_20[1] = 0.9052779937121489;
  params.uk_20[0] = -0.07904017565835986;
  params.alpha_20[0] = 1.6842063717532936;
  params.xk_21[0] = 0.979009293697437;
  params.xk_21[1] = 0.6413036255984501;
  params.uk_21[0] = 1.6559010680237511;
  params.alpha_21[0] = 1.2673311275751495;
  params.xk_22[0] = -0.5362376605895625;
  params.xk_22[1] = 0.2113782926017822;
  params.uk_22[0] = -1.2144776931994525;
  params.alpha_22[0] = 0.38414459278720625;
  params.xk_23[0] = 0.9026784957312834;
  params.xk_23[1] = 1.1397468137245244;
  params.uk_23[0] = 1.8883934547350631;
  params.alpha_23[0] = 1.7019428340830034;
  params.xk_24[0] = 0.17437730638329096;
  params.xk_24[1] = -1.6408365219077408;
  params.uk_24[0] = -0.04450702153554875;
  params.alpha_24[0] = 1.8558726951242512;
  params.xk_25[0] = 1.1504727980139053;
  params.xk_25[1] = -0.05962309578364744;
  params.uk_25[0] = -0.1788825540764547;
  params.alpha_25[0] = 0.43597153681870715;
  params.xk_26[0] = -1.2911464767927057;
  params.xk_26[1] = -1.7055053231225696;
  params.uk_26[0] = 1.56957275034837;
  params.alpha_26[0] = 1.2803532337981178;
  params.xk_27[0] = -1.4266707301147146;
  params.xk_27[1] = -0.3434923211351708;
  params.uk_27[0] = -1.8035643024085055;
  params.alpha_27[0] = 0.4187466990447273;
  params.xk_28[0] = 0.9228324965161532;
  params.xk_28[1] = 0.6044910817663975;
  params.uk_28[0] = -0.0840868104920891;
  params.alpha_28[0] = 0.5495610109912785;
  params.xk_29[0] = 0.608892500264739;
  params.xk_29[1] = 1.8257980452695217;
  params.uk_29[0] = -0.25791777529922877;
  params.alpha_29[0] = 0.14026501017534043;
  params.xk_30[0] = -1.7690740487081298;
  params.xk_30[1] = -1.6685159248097703;
  params.uk_30[0] = 1.8388287490128845;
  params.alpha_30[0] = 1.0815216723729877;
  params.xk_31[0] = 1.3498497306788897;
  params.xk_31[1] = -1.3198658230514613;
  params.uk_31[0] = -0.9586197090843394;
  params.alpha_31[0] = 1.3839550237456855;
  params.xk_32[0] = 1.5822813125679343;
  params.xk_32[1] = -0.6372460621593619;
  params.uk_32[0] = -1.741307208038867;
  params.alpha_32[0] = 1.7282393388212876;
  params.xk_33[0] = -0.8365102166820959;
  params.xk_33[1] = 0.9643296255982503;
  params.uk_33[0] = -1.367865381194024;
  params.alpha_33[0] = 1.3899268702817518;
  params.xk_34[0] = 1.3656784761245926;
  params.xk_34[1] = 0.9086083149868371;
  params.uk_34[0] = -0.5635699005460344;
  params.alpha_34[0] = 1.4533795029803958;
  params.xk_35[0] = -1.4421315032701587;
  params.xk_35[1] = -0.7447235390671119;
  params.uk_35[0] = -0.32166897326822186;
  params.alpha_35[0] = 1.7544240778886342;
  params.xk_36[0] = -1.385039165715428;
  params.xk_36[1] = 1.5204991609972622;
  params.uk_36[0] = 1.1958572768832156;
  params.alpha_36[0] = 1.9432485941559614;
  params.xk_37[0] = -0.5291880667861584;
  params.xk_37[1] = -1.1802409243688836;
  params.uk_37[0] = -1.037718718661604;
  params.alpha_37[0] = 1.6557256028428418;
  params.xk_38[0] = 1.8609125943756615;
  params.xk_38[1] = 0.7952399935216938;
  params.uk_38[0] = -0.07001183290468038;
  params.alpha_38[0] = 0.5740995293622657;
  params.xk_39[0] = 1.3347515373726386;
  params.xk_39[1] = 1.4887180335977037;
  params.uk_39[0] = -1.6314736327976336;
  params.alpha_39[0] = 0.43189894203955337;
  params.xk_40[0] = 1.327044361831466;
  params.xk_40[1] = 1.3932155883179842;
  params.uk_40[0] = -0.7413880049440107;
  params.alpha_40[0] = 0.5585891936937126;
  params.xk_41[0] = -0.27673991192616;
  params.xk_41[1] = 0.15778600105866714;
  /* Make this a diagonal PSD matrix, even though it's not diagonal. */
  params.Q_final[0] = 1.0955668150066136;
  params.Q_final[2] = 0;
  params.Q_final[1] = 0;
  params.Q_final[3] = 1.8369121387136151;
  params.delta_t[0] = 1.069469740702642;
  params.c1[0] = 1.5499356300818472;
  params.cos_xk_0[0] = -1.0766549376946926;
  params.c2[0] = 1.9305867022127314;
  params.abs_xk_0[0] = 1.5020546146367586;
  params.Bd[0] = 0.6861877287839229;
  params.cos_xk_1[0] = 1.794110587839819;
  params.abs_xk_1[0] = 1.4010235579325456;
  params.cos_xk_2[0] = 1.362244341944948;
  params.abs_xk_2[0] = 0.09099461171173773;
  params.cos_xk_3[0] = -1.7774338357932473;
  params.abs_xk_3[0] = 1.4854745470992576;
  params.cos_xk_4[0] = -0.7812542682064318;
  params.abs_xk_4[0] = 1.0335687316864905;
  params.cos_xk_5[0] = -1.374950305314906;
  params.abs_xk_5[0] = 1.9559048193139694;
  params.cos_xk_6[0] = 0.011004190697677885;
  params.abs_xk_6[0] = 1.6580021569494507;
  params.cos_xk_7[0] = -1.7038488148800144;
  params.abs_xk_7[0] = 0.9578309044356763;
  params.cos_xk_8[0] = -1.7508820783768964;
  params.abs_xk_8[0] = 1.7684828621754745;
  params.cos_xk_9[0] = -0.21675928514816478;
  params.abs_xk_9[0] = 0.13709983652367352;
  params.cos_xk_10[0] = -1.6940148707361717;
  params.abs_xk_10[0] = 1.07758531600634;
  params.cos_xk_11[0] = -1.697734381979077;
  params.abs_xk_11[0] = 0.3675446360248855;
  params.cos_xk_12[0] = -0.2545716633339441;
  params.abs_xk_12[0] = 0.9955656620369149;
  params.cos_xk_13[0] = 0.3332476609670296;
  params.abs_xk_13[0] = 1.2410253628098147;
  params.cos_xk_14[0] = -0.5087540014293261;
  params.abs_xk_14[0] = 1.2374731659611597;
  params.cos_xk_15[0] = -1.371021366459455;
  params.abs_xk_15[0] = 0.5510169508673872;
  params.cos_xk_16[0] = 1.194873082385242;
  params.abs_xk_16[0] = 0.30617860145303233;
  params.cos_xk_17[0] = -1.106708108457053;
  params.abs_xk_17[0] = 0.48595635938791015;
  params.cos_xk_18[0] = -0.08197078070773234;
  params.abs_xk_18[0] = 0.001491044083795856;
  params.cos_xk_19[0] = -1.878754557910134;
  params.abs_xk_19[0] = 0.923096303295611;
  params.cos_xk_20[0] = -1.349917260533923;
  params.abs_xk_20[0] = 1.3590036075465703;
  params.cos_xk_21[0] = 1.1808183487065538;
  params.abs_xk_21[0] = 1.1563267174754204;
  params.cos_xk_22[0] = 0.7790599086928229;
  params.abs_xk_22[0] = 0.7819160314677573;
  params.cos_xk_23[0] = -1.8148151880282066;
  params.abs_xk_23[0] = 0.8788430652592987;
  params.cos_xk_24[0] = -0.5120787511622411;
  params.abs_xk_24[0] = 1.1940064844006602;
  params.cos_xk_25[0] = -1.4631273212038676;
  params.abs_xk_25[0] = 0.45542579344367184;
  params.cos_xk_26[0] = 1.2591296661091191;
  params.abs_xk_26[0] = 0.5286510532804263;
  params.cos_xk_27[0] = -0.358719180371347;
  params.abs_xk_27[0] = 1.8719443529915631;
  params.cos_xk_28[0] = -0.8977901479165817;
  params.abs_xk_28[0] = 0.29057991770712777;
  params.cos_xk_29[0] = 0.8080805173258092;
  params.abs_xk_29[0] = 1.1341331008825493;
  params.cos_xk_30[0] = 0.44637534218638786;
  params.abs_xk_30[0] = 0.08406170198714724;
  params.cos_xk_31[0] = -0.3309324209710929;
  params.abs_xk_31[0] = 0.008532868334318877;
  params.cos_xk_32[0] = -1.013858124556442;
  params.abs_xk_32[0] = 1.4121123671680127;
  params.cos_xk_33[0] = -1.753837136317201;
  params.abs_xk_33[0] = 0.5893869972065597;
  params.cos_xk_34[0] = 1.9524510112487126;
  params.abs_xk_34[0] = 1.942444460453951;
  params.cos_xk_35[0] = -0.0726144452811801;
  params.abs_xk_35[0] = 1.4713867730564918;
  params.cos_xk_36[0] = 0.5306230967445558;
  params.abs_xk_36[0] = 0.9313861428874735;
  params.cos_xk_37[0] = 1.4282657305652786;
  params.abs_xk_37[0] = 0.345036504332358;
  params.cos_xk_38[0] = 1.3137276889764422;
  params.abs_xk_38[0] = 0.0841390469166361;
  params.cos_xk_39[0] = 1.4678147672511939;
  params.abs_xk_39[0] = 1.3519931749364955;
  params.cos_xk_40[0] = -0.2163435603565258;
  params.abs_xk_40[0] = 1.343140495268554;
  params.new_EF_0[0] = 0.9207370077784838;
  params.old_EF_0[0] = 1.5600064447571704;
  params.disturbance_0[0] = 0.2268881677282346;
  params.Cd_max[0] = 1.0163148576972107;
  params.I[0] = 1.7429790798877458;
  params.old_EF_1[0] = 1.855058551624045;
  params.disturbance_1[0] = 0.44067266309662534;
  params.old_EF_2[0] = 0.5038606051092378;
  params.disturbance_2[0] = 1.8080249432179774;
  params.old_EF_3[0] = 0.6910346774302569;
  params.disturbance_3[0] = 0.11374514809743119;
  params.old_EF_4[0] = 1.4297733442240657;
  params.disturbance_4[0] = 0.8288377183067157;
  params.old_EF_5[0] = 1.470648374990288;
  params.disturbance_5[0] = 0.9541832668867387;
  params.old_EF_6[0] = 1.0011311088728638;
  params.disturbance_6[0] = 0.835123820817179;
  params.old_EF_7[0] = 0.580969792070303;
  params.disturbance_7[0] = 1.801421734774702;
  params.old_EF_8[0] = 1.3375751559702145;
  params.disturbance_8[0] = 1.5776646866859343;
  params.old_EF_9[0] = 1.7914790621862346;
  params.disturbance_9[0] = 0.5003778847787201;
  params.old_EF_10[0] = 1.8396412279448449;
  params.disturbance_10[0] = 1.7252101745171162;
  params.old_EF_11[0] = 1.0121705242499728;
  params.disturbance_11[0] = 1.1358043482880613;
  params.old_EF_12[0] = 0.2298644760735571;
  params.disturbance_12[0] = 1.5242316811155372;
  params.old_EF_13[0] = 0.3464500143686473;
  params.disturbance_13[0] = 1.067672082011819;
  params.old_EF_14[0] = 0.2528746104574384;
  params.disturbance_14[0] = 0.1458341871643145;
  params.old_EF_15[0] = 1.218054887521129;
  params.disturbance_15[0] = 0.98240625923136;
  params.old_EF_16[0] = 1.3496198694785453;
  params.disturbance_16[0] = 1.5817083661085687;
  params.old_EF_17[0] = 1.9653749852911324;
  params.disturbance_17[0] = 0.16816136215336264;
  params.old_EF_18[0] = 1.2624242248671609;
  params.disturbance_18[0] = 1.1539497907628957;
  params.old_EF_19[0] = 1.301284353583406;
  params.disturbance_19[0] = 1.0863589096287594;
  params.old_EF_20[0] = 1.1147347750604033;
  params.disturbance_20[0] = 1.7371092672809771;
  params.old_EF_21[0] = 0.9040232327431506;
  params.disturbance_21[0] = 1.0699511572607228;
  params.old_EF_22[0] = 1.3819274075305301;
  params.disturbance_22[0] = 0.17898998279021772;
  params.old_EF_23[0] = 0.8638506377746196;
  params.disturbance_23[0] = 0.2042684414089766;
  params.old_EF_24[0] = 0.2756197858220666;
  params.disturbance_24[0] = 0.004251116931818011;
  params.old_EF_25[0] = 0.4194128723232424;
  params.disturbance_25[0] = 0.43327452487646845;
  params.old_EF_26[0] = 1.0324889624688858;
  params.disturbance_26[0] = 1.1404164769804863;
  params.old_EF_27[0] = 1.6479223610064944;
  params.disturbance_27[0] = 0.9734223776463142;
  params.old_EF_28[0] = 1.7829091978435834;
  params.disturbance_28[0] = 0.7901215795503316;
  params.old_EF_29[0] = 1.489222894168885;
  params.disturbance_29[0] = 1.1055145248347646;
  params.old_EF_30[0] = 1.2476501715446522;
  params.disturbance_30[0] = 0.5407839937666252;
  params.old_EF_31[0] = 1.875190015879578;
  params.disturbance_31[0] = 1.5393094307157957;
  params.old_EF_32[0] = 0.29119005813981325;
  params.disturbance_32[0] = 1.074868739889147;
  params.old_EF_33[0] = 1.991572611111171;
  params.disturbance_33[0] = 0.09811266501026328;
  params.old_EF_34[0] = 0.6056396758352269;
  params.disturbance_34[0] = 1.4816267427043326;
  params.old_EF_35[0] = 0.07872289530522969;
  params.disturbance_35[0] = 1.4933421819845165;
  params.old_EF_36[0] = 1.146842559967522;
  params.disturbance_36[0] = 1.4634113511241331;
  params.old_EF_37[0] = 1.1016651917532665;
  params.disturbance_37[0] = 1.8788069566023176;
  params.old_EF_38[0] = 0.692803405800541;
  params.disturbance_38[0] = 1.148938919872456;
  params.old_EF_39[0] = 0.10155995800455253;
  params.disturbance_39[0] = 1.1068656683087137;
  params.old_EF_40[0] = 0.8387858872958742;
  params.disturbance_40[0] = 1.966323575580403;
  params.lambda[0] = 1.8912146376740893;
  params.omega_0[0] = 0.2765588297162007;
  params.w_max[0] = 0.0832312830619244;
  params.u_max[0] = 0.24135013413781436;
  params.delta_u_max[0] = 0.3854939354396405;
  params.alpha_max[0] = 1.4523359886211047;
  params.delta_alpha_max[0] = 1.0879559070774472;
  params.omega_max[0] = 1.069850669070563;
}
